#include "common/inc/Graph.hpp"
#include "common/inc/GraphInt.hpp"
using namespace mpc;

#include <iostream>
using namespace std;

int main()
{
  GraphInt graph;
  DGVertex_iterator<int> vertex1 = graph.addVertex(1);
  DGVertex_iterator<int> vertex2 = graph.addVertex(2);
  DGVertex_iterator<int> vertex3 = graph.addVertex(3);
  DGVertex_iterator<int> vertex4 = graph.addVertex(4);
  DGVertex_iterator<int> vertex5 = graph.addVertex(5);
  DGVertex_iterator<int> vertex6 = graph.addVertex(6);
  DGVertex_iterator<int> vertex7 = graph.addVertex(7);
  DGVertex_iterator<int> vertex8 = graph.addVertex(8);

  graph.addEdge(vertex1, vertex2);
  graph.addEdge(vertex1, vertex3);
  graph.addEdge(vertex2, vertex4);
  graph.addEdge(vertex3, vertex5);
  graph.addEdge(vertex3, vertex6);
  graph.addEdge(vertex3, vertex7);
  graph.addEdge(vertex5, vertex4);
  graph.addEdge(vertex4, vertex8);

  cout << "Complete graph: " << endl;
  graph.display();

//   graph.removeVertex(vertex2);

//   cout << "Graph with 2 removed: " << endl;
//   graph.display();

  std::vector<DGVertex_iterator<int> > roots = graph.rootVertices();
  cout << "Root vertices : " << endl;
  for(int i=0; i<roots.size(); i++) cout << (*(roots.at(i)))->val() << "  ";
  cout << endl;

  cout << "Beginning graph to tree..." << endl;
  Node<int>* tree = graph.toTree();
  cout << "Ending graph to tree..." << endl;

  cout << "Tree : " << endl;
  if(tree == NULL) cout << "Tree NULL" << endl;
  else cout << "Tree not NULL" << endl;

  vector<int> vecLeaves;
  cout << "Beginning get leaves val..." << endl;
  tree->getLeavesVal(vecLeaves);
  cout << "Ending get leaves val..." << endl;
  cout << "Tree leaves : ";
  for(int i=0; i<vecLeaves.size(); i++) cout << vecLeaves.at(i) << " ";
  cout << endl;

  // compute the list of every branches of the tree
  std::vector< std::vector<int>* > vecBranches = tree->computeAllBranches();

  cout << "Branches : " << endl;
  for(int i=0; i<vecBranches.size(); i++)
    {
      cout << "branch " << i << " : ";
      for(int j=0; j<vecBranches.at(i)->size(); j++)
	{
	  cout << vecBranches.at(i)->at(j) << " -> ";
	}
      cout << endl;
    }

  delete tree;

  return 0;
}
