#include "common/inc/GraphInt.hpp"
using namespace mpc;

#include <iostream>
using namespace std;

                                    /**************************************************/
                                    /****************** Class GraphInt ****************/
                                    /**************************************************/

/********** Constructors and destructors **********/

/**
 *  \brief default constructor
 */
GraphInt::GraphInt() : DGraph<int>()
{
}

/**
 *  \brief default constructor
 */
GraphInt::GraphInt(const GraphInt& g) : DGraph<int>(g)
{
}

/**
 *  \brief destructor
 */
GraphInt::~GraphInt()
{
}


/**************** Display functions ***************/

/**
 *  \brief display the graphe
 */
void GraphInt::display()
{
      std::cout << "Graphe vertices (" << this->vertices_.size() << ") : " << std::endl;
      for(std::list< DGVertex<int>* >::iterator it = this->vertices_.begin(); it != this->vertices_.end(); it++) 
	{
	  cout << (*it)->val() << endl;
	}

      std::cout << "Graphe edges (" << this->edges_.size() << ") " << std::endl;      
      for(std::list< DGEdge<int>* >::iterator it2 = this->edges_.begin(); it2 != this->edges_.end(); it2++) 
	{
	  cout << (*it2)->startVertex()->val() << " -> " << (*it2)->endVertex()->val() << endl;
	}
}
