#include "Tree.hpp"
using namespace mpc;

                                    /**************************************************/
                                    /******************* Class Node *******************/
                                    /**************************************************/

/********** Constructors and destructors **********/

/**
 *  \brief default constructor
 */
template <typename T> Node<T>::Node()
{
  this->father() = NULL;
}

/**
 *  \brief copy constructor
 *  \param n : the node to copy
 */
template <typename T> Node<T>::Node(const Node<T>& n)
{
  this->father() = n.father();
  int N = n.nbSons();
  for(int i=0; i<N; i++)
    this->addSon(n.son(i));
  this->val() = n.val();
}

/**
 *  \brief init constructor
 *  \param val : the value contained in the node
 */  
template <typename T> Node<T>::Node(T val)
{
  this->father() = NULL;
  this->val()    = val;
}

/**
 *  \brief destructor
 */
template <typename T> Node<T>::~Node()
{
  // nothing to do
}


/*************** Getters and Setters **************/

/**
 *  \brief add a son to the current node
 *  \param s : a pointer to the new son
 */
template <typename T> void Node<T>::addSon(Node<T>* s) 
{
  this->sons_->push_back(s); 
  s->father_ = this;
}


//                                     /**************************************************/
//                                     /******************* Class Tree *******************/
//                                     /**************************************************/

// /********** Constructors and destructors **********/
  
// /**
//  *  \brief default constructor
//  */
// template <typename T> Tree<T>::Tree() : Node<T>()
// {
// }

// /**
//  *  \brief init constructor
//  *  \param val : the value contained in the node
//  */
// template <typename T> Tree<T>::Tree(T val) : Node<T>(val)
// {
// }

// /**
//  *  \brief init constructor
//  *  \param val : the value contained in the node
//  */
// template <typename T> Tree<T>::Tree(const Node<T>& n) : Node<T>(n)
// {
// }

// /**
//  *  \brief destructor
//  */
// template <typename T> Tree<T>::~Tree()
// {
// }
