#include "motion/inc/PCTraj.hpp"
#include "motion/inc/PSTraj.hpp"
#include "gnuplot/inc/TrajPlot.hpp"
using namespace mpc;

#include <iostream>
using namespace std;

int main()
{
  double v0_1 = 1.0;
  Polynomial polyAcc_1(1,2,3);
  double w0_1 = 0.5;
  Polynomial polyAAcc_1(1,2,3);

//   double v0_2 = 1.2;
//   Polynomial polyAcc_2(0.020,0.025,-0.045);
//   double w0_2 = 0.0;
//   Polynomial polyAAcc_2(-0.005,0.001,-0.030);

  ManaPCTraj ctraj4(v0_1, polyAcc_1, w0_1, polyAAcc_1, 5.0);
  cout << "ctraj4 before shift : " << endl;
  ctraj4.display();
  cout << endl;
  
//   ManaPCTraj ctraj5(v0_2, polyAcc_2, w0_2, polyAAcc_2, 4.0);
//   ManaPCTraj ctraj6(ctraj4);
//   ManaPCTraj ctraj7(ctraj5);

  // display the control trajectory in a gnuplot window
  TrajPlot::plotDD2PCTraj(ctraj4, NULL, false, 2000);

//   // display the control trajectory in a gnuplot window
//   TrajPlot::plotDD2PCTraj(ctraj5, NULL, false, 2000);

//   ctraj4.concat(ctraj5);
//   ctraj4.concat(ctraj6);
//   ctraj4.concat(ctraj7);
//   cout << "ctraj4 concat 5,6,7: "; ctraj4.display(); cout << endl;

  ctraj4.shift(6);

  cout << "ctraj4 after shift : " << endl;
  ctraj4.display();
  cout << endl;

  // display the control trajectory in a gnuplot window
  TrajPlot::plotDD2PCTraj(ctraj4, NULL, false, 2000);

//   ManaState s0(10.0,20.0,0.0,1.2,0.13);

// //   // ManaPSTraj straj(const ManaState& s, const ManaPCTraj& ctraj, double minV, double maxV, double minW, double maxW);
//   ManaPSTraj straj(s0, ctraj4);
//   cout << "straj : "; straj.display(); cout << endl;

//   // display the state trajectory in a gnuplot window
//   TrajPlot::plotDD2PSTraj(straj, NULL, false, 2000);

  return 0;
}
