#ifndef INVMATRIX_HPP
#define INVMATRIX_HPP

#include "nrtypes.h"
#include "nr.h"
#include "nrutil.h"

#include <cmath>

/********** Standard operations on matrices **********/
void prodMatDP(const Mat_DP& A, const Mat_DP& B, Mat_DP& AB);  // return the product of two matrices A and B
void transpMatDP(const Mat_DP& A, Mat_DP& At);                 // return the transpose of a matrix A

/*************** Inversion of matrices ***************/
void luInvMatDP(const Mat_DP& A, Mat_DP& Ainv);                // return the inverse of a matrix A (LU decomposition)
void svdInvMatDP(const Mat_DP& A, Mat_DP& Ainv);               // return the pseudo inverse of a matrix A (SVD)
void invMatDP(const Mat_DP& A, Mat_DP& Ainv);                  // return the inverse or pseudo inverse of a matrix A

/***************** Utility functions *****************/
void displayMatDP(const Mat_DP& A);                            // display a matrix A

#endif // INVMATRIX_HPP
