#include "Interval.hpp"

#include <iostream>
using namespace std;

int main()
{
  Interval itv1(0,CLOSE_B,4,CLOSE_B);
  Interval itv2(8,CLOSE_B,17,CLOSE_B);
  Interval itv3(18,CLOSE_B,21,CLOSE_B);

  PiecewiseItv itv1U2;
  PiecewiseItv itvP3(itv3);
  PiecewiseItv itv1U2U3;

  cout << "itv1 : "; itv1.display(); cout << endl;
  cout << "itv2 : "; itv2.display(); cout << endl;
  cout << "itv3 : "; itv3.display(); cout << endl;
  cout << "itvP3 : "; itvP3.display(); cout << endl;

  unionItv(itv1,itv2,itv1U2);
  cout << "itv1U2 : "; itv1U2.display(); cout << endl;
  unionItv(itv1U2,itvP3,itv1U2U3);
  cout << "itv1U2U3 : "; itv1U2U3.display(); cout << endl;

  PiecewiseItv itv4(3,CLOSE_B,9,CLOSE_B);
  PiecewiseItv itv5(10,CLOSE_B,12,CLOSE_B);
  PiecewiseItv itv6(20,CLOSE_B,22,CLOSE_B);
  PiecewiseItv itv7(23,CLOSE_B,25,CLOSE_B);

  PiecewiseItv itv4U5;
  PiecewiseItv itv4U5U6;
  PiecewiseItv itv4U5U6U7;

  unionItv(itv4,itv5,itv4U5);
  cout << "itv4U5 : "; itv4U5.display(); cout << endl;
  unionItv(itv4U5,itv6,itv4U5U6);
  cout << "itv4U5U6 : "; itv4U5U6.display(); cout << endl;
  unionItv(itv4U5U6,itv7,itv4U5U6U7);
  cout << "itv4U5U6U7 : "; itv4U5U6U7.display(); cout << endl;

  PiecewiseItv intersecAllItv;
  intersecItv(itv1U2U3,itv4U5U6U7,intersecAllItv);
  cout << "intersecAllItv : "; intersecAllItv.display(); cout << endl;


  PiecewiseItv unionAllItv;
  unionItv(itv1U2U3,itv4U5U6U7,unionAllItv);
  cout << "unionAllItv : "; unionAllItv.display(); cout << endl;

  Interval greatItv(-1,CLOSE_B,30,CLOSE_B);
  PiecewiseItv complement;
  complementItv(unionAllItv,greatItv,complement);
  cout << "complement : "; complement.display(); cout << endl;

  return 0;
}
