#include "Polynomial.hpp"
#include "MultiItvFunction.hpp"

#include "Utils.hpp"
#include "gnuplot/inc/gnuplot_i.hpp"
using namespace mpc;

#include <iostream>
using namespace std;

#define STEP 300
#define BINF -10.0
#define BSUP 15.0

int main()
{
  Polynomial* poly1 = new Polynomial(0.05,0.33,3,-1);
  Polynomial* poly2 = new Polynomial(20.0);
  Polynomial* poly3 = new Polynomial(*poly2);
  (*poly3) *= -1.0;
  
  MultiItvFunction mitvPoly1(poly1,poly1->binf_,poly1->bsup_);
//   MultiItvFunction mitvPoly2(poly2->binf_,poly2->bsup_,poly2);

  cout << "poly1 avant bounding" << endl;
  mitvPoly1.display();
  cout << "poly2 : " << endl;
  poly2->display();
  cout << "poly3 : " << endl;
  poly3->display();

  mitvPoly1.changeItv(1.0,2.0,poly2);

  cout << "poly1 apres 1er bounding" << endl;
  mitvPoly1.display();  

  mitvPoly1.changeItv(1.0,2.0,poly3);

  cout << "poly1 apres 2nd bounding" << endl;
  mitvPoly1.display();  

//   MultiItvFunction copyMitvPoly2(mitvPoly2);
//   copyMitvPoly2 -= mitvPoly1;
//   std::vector<double> rdiff;
//   copyMitvPoly2.realRoots(rdiff);

//   cout << "Roots diff : " << endl;
//   for(int i=0; i<rdiff.size(); i++)
//     {
//       cout << "f(" << rdiff[i] << ") = " << copyMitvPoly2.getVal(rdiff[i]) << endl;
//     }
//   cout << endl;

//   // compute the ladder of time
//   double dt = (BSUP - BINF) / STEP;
//   vector<double> stime;
//   for(int i=0; i<=STEP; i++)
//     {
//       stime.push_back(BINF + i*dt);
//     }

//   // sample the three functions
//   vector<double> spoly1,spoly2,sdiff;
//   mitvPoly1.sample(BINF, BSUP, STEP, spoly1);
//   mitvPoly2.sample(BINF, BSUP, STEP, spoly2);
//   copyMitvPoly2.sample(BINF, BSUP, STEP, sdiff);

//   // display the three functions in gnuplot windows
//   Gnuplot gPoly1;
//   gPoly1.reset_plot();
//   gPoly1.set_style("points").plot_xy(stime,spoly1,"1st polynom");
//   gPoly1.set_style("points").plot_xy(stime,spoly2,"2nd polynom");

// //   Gnuplot gDiff;
// //   gDiff.reset_plot();
// //   gDiff.set_style("points").plot_xy(stime,sdiff,"Difference");

//   cout << "fct avant bound : " << endl;
//   mitvPoly1.display();

//   wait_for_key();

//   // add mitvPoly2 as a bound for function mitvPoly1
//   mitvPoly1.addMaxBound(&mitvPoly2);

//   // sample the new function
//   vector<double> spoly12;
//   mitvPoly2.sample(BINF, BSUP, STEP, spoly12);

//   cout << "fct apres bound : " << endl;
//   mitvPoly1.display();

// //   cout << "spoly12.size() : " << spoly12.size() << endl;
// //   cout << "stime.size() : " << stime.size() << endl;
  
// //   for(int i=0; i<spoly12.size(); i++)
// //     {
// //       cout << stime[i] << ":" << spoly12[i] << endl;
// //     }

// //   vector<double> spoly12copy, stimecopy;
// //   for(int i=0; i<100; i++)
// //     {
// //       spoly12copy.push_back(spoly12[i]);
// //       stimecopy.push_back(stime[i]);
// //     }

//   // display the three functions in gnuplot windows
//   Gnuplot gPoly2;
//   gPoly2.reset_plot();
//   gPoly2.set_style("points").plot_xy(stime,spoly1,"1st polynom");
//   gPoly2.set_style("points").plot_xy(stime,spoly2,"2nd polynom");
//   gPoly2.set_style("points").plot_xy(stime,spoly12,"polynom with bound");
//   //gPoly2.set_style("points").plot_x(stime,"argh");

//   wait_for_key();

  return 0;
}
