#include "Matrix.hpp"

#include <cstring>

                                    /**************************************************/
                                    /****************** Class Matrix2D ****************/
                                    /**************************************************/

/********** Constructors and destructors **********/

/**
 *  \brief default constructor
 *
 *  May only be used by subclasses
 */
template <typename T> 
Matrix2D<T>::Matrix2D()
{
}

/**
 *  \brief init constructor
 *  \param dim1 : size of the first dimension
 *  \param dim2 : size of the second dimension
 */
template <typename T> 
Matrix2D<T>::Matrix2D(int dim1,int dim2)
{
}

/**
 *  \brief copy constructor
 *  \param m2 : the input matrix to copy
 */
template <typename T> 
Matrix2D<T>::Matrix2D(const Matrix2D& m2)
{
}

/***************** Initialization *****************/

/**
 *  \brief clear the matrix
 */
template <typename T> void Matrix2D<T>::clear()
{
}

/**
 *  \brief initialize the matrix table from its new dimensions
 *  \param dim1 : size of the first dimension
 *  \param dim2 : size of the second dimension
 */
template <typename T> 
void Matrix2D<T>::init(int dim1,int dim2)
{
}

/******************** Operators *******************/

/**
 *  \brief return a value contained in the matrix
 *  \param i : index of the first dimension
 *  \param j : index of the second dimension
 *  \return the value of the matrix at index [i,j]
 */
template <typename T>
const T* Matrix2D<T>::operator[](int i) const
{
}

/**
 *  \brief return a reference to a value contained in the matrix
 *  \param i : index of the first dimension
 *  \param j : index of the second dimension
 *  \return a reference to the value of the matrix at index [i,j]
 */
template <typename T>
T* Matrix2D<T>::operator[](int i)
{
}

/**************** Display functions ***************/

/**
 *  \brief display the content of the matrix
 */
template <typename T>
void Matrix2D<T>::display() const
{
}


                                    /**************************************************/
                                    /****************** Class Matrix3D ****************/
                                    /**************************************************/

/********** Constructors and destructors **********/

/**
 *  \brief default constructor
 *
 *  May only be used by subclasses
 */
template <typename T>
Matrix3D<T>::Matrix3D()
{
  this->dim1_ = 0;
  this->dim2_ = 0;
  this->dim3_ = 0;
  this->tab_ = NULL;
}

/**
 *  \brief init constructor
 *  \param dim1 : size of the first dimension
 *  \param dim2 : size of the second dimension
 */
template <typename T>
Matrix3D<T>::Matrix3D(int dim1,int dim2,int dim3)
{
  this->dim1_ = 0;
  this->dim2_ = 0;
  this->dim3_ = 0;
  this->tab_ = NULL;

  this->init(dim1,dim2,dim3);
}

/**
 *  \brief copy constructor
 *  \param m2 : the input matrix to copy
 */
template <typename T>
Matrix3D<T>::Matrix3D(const Matrix3D& m2)
{
  this->clear();
}


/***************** Initialization *****************/

/**
 *  \brief clear the matrix
 */
template <typename T>
void Matrix3D<T>::clear()
{
  if(tab_ != NULL)
    {
      for(int i=0; i<dim1_; i++)
	{
	  for(int j=0; j<dim2_; j++)
	    {
	      delete tab_[i][j];
	    }
	  delete tab_[i];
	}
      delete tab_;
    }
  tab_ = NULL;
}

/**
 *  \brief initialize the matrix table from its new dimensions
 *  \param dim1 : size of the first dimension
 *  \param dim2 : size of the second dimension
 *  \param dim3 : size of the third dimension
 */
template <typename T>
void Matrix3D<T>::init(int dim1,int dim2,int dim3)
{
  this->clear();
  tab_ = new T*[dim1];
  for(int i=0; i<dim1; i++)
    {
      tab_[i] = new T[dim2];
//       for()
// 	{
// 	}
    }
}


/******************** Operators *******************/

/**
 *  \brief return a value contained in the matrix
 *  \param i : index of the first dimension
 *  \param j : index of the second dimension
 *  \return the value of the matrix at index [i,j]
 */
template <typename T>
const T* Matrix3D<T>::operator[](int i) const
{
  return tab_[i];
}

/**
 *  \brief return a reference to a value contained in the matrix
 *  \param i : index of the first dimension
 *  \param j : index of the second dimension
 *  \return a reference to the value of the matrix at index [i,j]
 */
template <typename T>
T* Matrix3D<T>::operator[](int i)
{
  return tab_[i];
}
