#include "Variable.hpp"

#include <cstring>
#include <cmath>

/********** Constructors and destructors **********/

// default constructor
Variable::Variable()
{
  this->val_ = 0.0;
  strcpy(this->name_,"\0");
}

// copy constructor
Variable::Variable(const Variable& v)
{
  this->val_ = v.val_;
  strcpy(this->name_,v.name_);
}

// init constructor
Variable::Variable(double val, char* name)
{
  this->val_ = val;
  if(name != NULL)
    strcpy(this->name_,name);
  else 
    strcpy(this->name_,"\0");
}

// destructor
Variable::~Variable()
{
}


/**************** Utility functions ***************/

// return true if the variable is named n
bool Variable::isNamed(const char* n) const
{
  if(n != NULL)
    {
      return (!strcmp(this->name_,n));
    }
  else
    {
      return false;
    }
}
