#include "motion/inc/PCTraj.hpp"
#include "motion/inc/PSTraj.hpp"
#include "math/inc/CosFunc.hpp"
#include "math/inc/MultFunc.hpp"
#include "math/inc/ItgFunc.hpp"
using namespace mpc;

#include <iostream>
using namespace std;

int main()
{
  ManaPCTraj ctraj1(1.2, 0.13, 5.0);

  ManaPCTraj ctraj2(5.8, -0.36, 4.5);
  ManaPCTraj ctraj3(1.7, 0.18, 3.2);

  cout << "ctraj1 : "; ctraj1.display(); cout << endl;
//   cout << "ctraj2 : "; ctraj2.display(); cout << endl;
//   cout << "ctraj3 : "; ctraj3.display(); cout << endl;

  ctraj1.concat(ctraj2);
  cout << "ctraj1 concat 2: "; ctraj1.display(); cout << endl;

  ctraj1.concat(ctraj3);
  cout << "ctraj1 concat 3: "; ctraj1.display(); cout << endl;

  ManaState s0(10.0,20.0,0.3*M_PI,1.2,0.13);

  // ManaPSTraj straj(const ManaState& s, const ManaPCTraj& ctraj, double minV, double maxV, double minW, double maxW);
  ManaPSTraj straj(s0, ctraj1);
  cout << "straj : "; straj.display(); cout << endl;

  ManaSTraj* sampledSTraj = straj.sample(0.5);
  cout << "sampledSTraj : "; sampledSTraj->display(); cout << endl;  
  delete sampledSTraj;

  ManaPSTraj straj2(straj);
  cout << "straj2 : "; straj2.display(); cout << endl;



//   const MultiItvFunction* funcVel1 = ctraj1.fctVel();
//   std::vector<Disc_Point> discPoints1;
//   funcVel1->getVecDiscPoints(discPoints1);
//   Function::displayDiscPoints(discPoints1);

//   ManaPCTraj ctraj4(1.2, 0.13, 6.0);
//   ManaPCTraj ctraj5(5.8, -0.36, 1.0);
//   ManaPCTraj ctraj6(1.7, 0.18, 3.0);
//   ManaPCTraj ctraj7(1.7, 0.18, 2.7);

//   ctraj4.concat(ctraj5);
//   ctraj4.concat(ctraj6);
//   ctraj4.concat(ctraj7);

//   const MultiItvFunction* funcVel4 = ctraj4.fctVel();
//   std::vector<Disc_Point> discPoints4;
//   funcVel4->getVecDiscPoints(discPoints4);
//   Function::displayDiscPoints(discPoints4);

//   CosFunc cosVel(new MultiItvFunction(*funcVel4));
//   MultFunc multVel(new MultiItvFunction(*funcVel1),new CosFunc(cosVel));

//   std::vector<Disc_Point> discPointsMult;
//   multVel.getVecDiscPoints(discPointsMult);
//   Function::displayDiscPoints(discPointsMult);

//   ItgFunc itgVel(new MultFunc(multVel));

//   cout << "Integral : " << endl;
//   itgVel.display();

  return 0;
}
