// stateClient.cpp : FAST robufast state client

#include <boost/bind.hpp>
#include <boost/smart_ptr.hpp>
#include <boost/asio.hpp>
#include <boost/thread.hpp>
#include <ctime>

using boost::asio::ip::tcp;
#include <iostream>
using namespace std;

int main(int argc, char* argv[])
{
  if (argc != 3)
    {
      std::cerr << "Usage : atgClient machine port" << std::endl;
      return 1;
    }
  
  boost::asio::io_service io_service;
  tcp::socket *s;
  boost::mutex mutex;
  
  std::string host(argv[1]);
  std::string port = argv[2];

  tcp::resolver resolver(io_service);
  tcp::resolver::query query(tcp::v4(), host, port);
  //  tcp::resolver::query query(host, port);
  std::cout << query.host_name() << " " << query.service_name() << std::endl;
  tcp::resolver::iterator iterator = resolver.resolve(query);
  
  s = new tcp::socket(io_service);
  s->connect(*iterator);

  int dsize = 2;
  double data[2];
  
  while(true)
    {
  try
    {
      do {
	
	// read data
// 	printf("Lexture Donnees \n");
	size_t len = boost::asio::read(*s,
				       boost::asio::buffer(data, dsize*sizeof(double)));
      
// 	printf("Fin Lexture Donnees \n");
	// process if size is correct
	if (len == dsize*sizeof(double)) {
	  
	  mutex.lock();
	  {
	    printf("  atg : (%.3f,%.3f)  \n", 
		   data[0], data[1]);

	  }
	  mutex.unlock();
	}
	
      } while (s->available() > 0);
      // receive as long as data is available
    }
  catch (std::exception& e)
    {
      std::cerr << "Exception: " << e.what() << "\n";
    
      // try to reconnect
      tcp::resolver resolver(io_service);
      tcp::resolver::query query(tcp::v4(), host, port);
      tcp::resolver::iterator iterator = resolver.resolve(query);
      
      s->connect(*iterator);
    }
    }  
}
