#include "FXGLColorLine.hpp"

FXGLColorLine::FXGLColorLine() : FXGLLine()
{
  
}

FXGLColorLine::FXGLColorLine(FXfloat x1,FXfloat y1,FXfloat z1,FXfloat x2,FXfloat y2,FXfloat z2) : 
FXGLLine(x1,y1,z1,x2,y2,z2) {}

FXGLColorLine::FXGLColorLine(FXfloat x1,FXfloat y1,FXfloat z1,FXfloat x2,FXfloat y2,FXfloat z2,FXfloat r,FXfloat g,FXfloat b,GLfloat w) : 
FXGLLine(x1,y1,z1,x2,y2,z2)
{
  this->color_ = FXVec3f(r,g,b);
  this->width_ = w;
}

FXVec3f FXGLColorLine::getColor() const
{
  return this->color_;
}

void FXGLColorLine::setColor(const FXVec3f& c)
{
  this->color_ = c;
}

GLfloat FXGLColorLine::getWidth() const
{
  return this->width_;
}

void FXGLColorLine::setWidth(const GLfloat& w)
{
  this->width_ = w;
}

void FXGLColorLine::draw(FXGLViewer* viewer)
{
  //#ifdef HAVE_GL_H
  glColor3f(color_[0],color_[1],color_[2]);
  glLineWidth(((GLfloat)(width_)));
  glBegin(GL_LINES);
  glVertex3fv(fm.pos);
  glVertex3fv(to.pos);
  glEnd();
  //#endif
}
