#include "FXGLColorPoint.hpp"

#include <iostream>
using namespace std;

FXGLColorPoint::FXGLColorPoint() : FXGLPoint()
{
  this->size_ = 1.0;
  this->color_ = FXVec3f(1.0f,0.0f,0.0f);
}

FXGLColorPoint::FXGLColorPoint(FXfloat x,FXfloat y,FXfloat z) : FXGLPoint(x,y,z) {}

FXGLColorPoint::FXGLColorPoint(FXfloat x,FXfloat y,FXfloat z,FXfloat r,FXfloat g,FXfloat b,GLfloat s) : FXGLPoint(x,y,z)
{
  this->color_ = FXVec3f(r,g,b);
  this->size_ = s;
}

FXVec3f FXGLColorPoint::getColor() const
{
  return this->color_;
}

void FXGLColorPoint::setColor(const FXVec3f& c)
{
  this->color_ = c;
}

GLfloat FXGLColorPoint::getSize() const
{
  return this->size_;
}

void FXGLColorPoint::setSize(const GLfloat& s)
{
  this->size_ = (GLfloat)s;
}

void FXGLColorPoint::draw(FXGLViewer* viewer)
{
  //#ifdef HAVE_GL_H
  glColor3f(color_[0],color_[1],color_[2]);
  glPointSize(((GLfloat)(size_)));
  glBegin(GL_POINTS);
  glVertex3fv(pos);
  glEnd();
  //#endif
}
