#include "FXMisc.hpp"


                 /**************************************************************************************/
                 /******************************* intersection functions *******************************/
                 /**************************************************************************************/

// compute the coefficients (a,b,c) of the equation given by a point p and a vector v
void coefEquFX(FXVec2d p,FXVec2d v,double* a,double* b,double *c)
{
	*a = v.y;
	*b = -v.x;
	*c = v.x * p.y - v.y * p.x;
}

// compute the intersection between the line defined by (p1,v1) and the line defined by (p2,v2)
// return false if both vectors are colinears
bool intersecLineFX2D(FXVec2d p1, FXVec2d v1, FXVec2d p2, FXVec2d v2, FXVec2d& pres)
{
	if(v1.x*v2.y - v1.y*v2.x != 0)
	{
		double a1,b1,c1;
		double a2,b2,c2;
		coefEquFX(p1,v1,&a1,&b1,&c1);
	        coefEquFX(p2,v2,&a2,&b2,&c2);
		
		// defining the result
		pres.x = -(c1*b2 - c2*b1)/(a1*b2 - a2*b1);
		pres.y = -(c1*a2 - c2*a1)/(b1*a2 - b2*a1);
		//pres.y = (-c1 + a1*(c1*b2 - c2*b1)/(a1*b2 - a2*b1))/(b1);
		return true;
	}
	else
	{
		return false;
	}
}
