#include <boost/program_options.hpp>
#include <boost/filesystem.hpp>
namespace po = boost::program_options;
namespace fs = boost::filesystem;

#include <cstring>
#include <iostream>
#include <fstream>
using namespace std;

int main()
{
  int val1 = 0;
  string val2 = string(":-(");

  po::options_description config_files("Configuration Files"); // Configuration files
  config_files.add_options() 
    ("Ctest.opt1", po::value<int>(&val1), "integer option")
    ("Ctest.opt2", po::value<string>(&val2), "string option")
    ;

  // Set variable map and configuration file details (main cfg file is hardcoded...)
  po::variables_map vm_config;
  fs::path cfg_path(fs::initial_path());
  cfg_path = fs::system_complete(fs::path("../code/foxIfc/cfg/test.cfg",fs::native));
  string cfg_string = cfg_path.native_file_string();
  if ( !fs::exists( cfg_path ) )
    {
      cout << "WARNING: Configuration file " << cfg_string;
      cout << " not found" << endl;
    }
  // Open configuration file
  ifstream ifs((const char *)cfg_string.c_str());
  store(parse_config_file(ifs, config_files), vm_config);
  notify(vm_config);

  cout << "val 1 : " << val1 << endl;
  cout << "val 2 : " << val2.c_str() << endl;

  return 0;
}
